Subject: Re: emulate -L sh impact on $0, $argv
From: "Nikolay Aleksandrovich Pavlov (ZyX)" <[email-masked]>
To: Sebastian Gniazdowski <[email-masked]>
Cc: Zsh hackers list <[email-masked]>
Date: Sun, 31 Jan 2016 23:04:10 +0300
List-Id: Zsh Workers List <zsh-workers.zsh.org>

31.01.2016, 22:14, "Sebastian Gniazdowski" <[email-masked]>:
> On 31 January 2016 at 19:12, Nikolay Aleksandrovich Pavlov (ZyX)
> <[email-masked]> wrote:
>>  And in any case has nothing to do with $0, $0 is never present in $argv.
>
> Are you sure? The examples show $0 is in $argv[0]

The example shows `source` in $0. Script name in $argv[0] is *not* $0, it is `source` argument, you may see it in $1 as well.

Best way to examine `$argv` content is

    () { emulate -L zsh ; builtin source <(<<< 'printf "<%s>\n" $0 $argv') }

(note: temporary file is not needed, `builtin` is present because my `source` is a function which sets localoptions and noaliases): this will print something like

    </proc/self/fd/11>

: in place of printing any arguments it prints only $0.

If I remove `builtin` here, leaving my function

    source () {
            setopt localoptions
            setopt noaliases
            builtin source "${@[@]}"
    }

(somewhat similar to your function) it will show that when arguments are not empty $1 is the same as $0, and if there are some arguments $1 is first argument given. ***But it is $1.*** Not sure whether or not this is a bug:

    () { emulate -L zsh ; source =(<<< 'printf "<%s>\n" $0 $argv') }
    </tmp/zshENNMpE>
    </tmp/zshENNMpE>
    () { emulate -L zsh ; source =(<<< 'printf "<%s>\n" $0 $argv') a b }
    </tmp/zshTUoQ9c>
    <a>
    <b>

. You see: no $0 in $argv in second example (my function for some reason does not work with fds, so I used `=()` and not `<()`).

And note the documentation: it explicitly states that `$argv` is the same thing as `$*` and `$*` is an array containing positional parameters. Even if there *was* `$0` in `$argv` it would be a *bug*.

>
>>  Array indexing *may* start with zero, controlled by KSH_ARRAYS
>>  option which is again different in zsh and sh emulation mode.
>
> In sh argv[0] is the same as argv[1]? Because again, you say I
> shouldn't be able to use argv[0] without KSH_ARRAYS, but in the
> examples, I do

In sh KSH_ARRAYS is set, so indexes are shifted.

>
> Best regards,
> Sebastian Gniazdowski